%Matlab code to evaluate the RC lowpass filter response of the seocnd 2-port problem
% problem of HWb, page 2, Feb 7, Fig 1, left.

clear all;close all;

NFT=1024; NF=1+NFT/2;%number of non-negative frequencies
Fmax=1e4; Fs=2*Fmax; Fmin=Fs/NFT;
f=0:Fmin:Fmax; %sweep frequency from 0 to Fmax [Hz] in steps of Fmin [Hz]

R1=1e4; %in [Ohms]
R2=1e4;
C=0.1e-6; %[Farads]
T=zeros(2,2,NF);

for k=1:NF; 
s=2*pi*f(k)*1j; %Define complex frequency

%Define three matrices for the three elements in the network
T1=[1 R1;0 1];
T2=[1 0; s*C 1];
T3=[1 R2;0 1];
T(:,:,k)=T1*T2*T3; %avoid all the messy algebra

%disp(sprintf('Freq=%g',f(k)))

end %end for freq loop

%plot some results:
kf=2:(NF-1);
A=squeeze(T(1,1,kf)); %Note: Octave did not require this squeeze() command (+ for Octave)
B=squeeze(T(1,2,kf));
C=squeeze(T(2,1,kf));
D=squeeze(T(2,2,kf));


%Plot |A|(f)
subplot(4,2,1)
loglog(f(kf)/1e3,abs(A));hold on;
%xlabel('Freq [Hz]')
ylabel('|A|(f)')
title('Tramsmission matrix |A|(f)');

subplot(4,2,3)
semilogx(f(kf)/1e3,1+angle(A)/pi,'g');
%xlabel('Freq [Hz]')
ylabel('\angle A(f)/pi')
%title('Tramsmission matrix |A|(f)');

%Plot |B|(f)
subplot(4,2,2)
%Plot |B|(f)
loglog(f(kf)/1e3,abs(B));
%xlabel('Freq [Hz]')
ylabel('B')
title('Tramsmission matrix |B|(f)');

subplot(4,2,4)
semilogx(f(kf)/1e3,1+angle(B)/pi,'g');
%xlabel('Freq [Hz]')
ylabel('\angle A(f)/pi')
%title('Tramsmission matrix |A|(f)');

%Plot |C|(f)
subplot(4,2,5)
%Plot |C|(f)
loglog(f(kf)/1e3,abs(C));
%xlabel('Freq [Hz]')
ylabel('C')
title('Tramsmission matrix |C|(f)');

subplot(4,2,7)
semilogx(f(kf)/1e3,1+angle(C)/pi,'g');
xlabel('Freq [Hz]')
ylabel('\angle A(f)/pi')
%title('Tramsmission matrix |A|(f)');

%Plot |C|(f)
subplot(4,2,6)
%Plot |D|(f)
loglog(f(kf)/1e3,abs(D))
%xlabel('Freq [Hz]')
ylabel('D')
title('Tramsmission matrix |D|(f)');

subplot(4,2,8)
semilogx(f(kf)/1e3,1+angle(D)/pi,'g');
xlabel('Freq [Hz]')
ylabel('\angle A(f)/pi')
%title('Tramsmission matrix |A|(f)');
